// A simple Win32 console application that writes the contents of the
// clipboard to standard output. Basically the opposite of clip.exe.
//
// Can be compiled with the MSVC linker option /NODEFAULTLIB in Release
// mode to get an executable that's just 3 KiB in size.

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <string.h>  // for strlen()

#ifndef NDEBUG
    #define mainCRTStartup main
#endif

int mainCRTStartup(void) {
    if (!OpenClipboard(NULL)) {
        ExitProcess(1);
    }
    HANDLE hData = GetClipboardData(CF_TEXT);
    if (!hData) {
        CloseClipboard();
        ExitProcess(1);
    }
    const char *str = (const char*) GlobalLock(hData);
    if (!str) {
        CloseClipboard();
        ExitProcess(1);
    }
    DWORD dummy;
    WriteFile(GetStdHandle(STD_OUTPUT_HANDLE), (const void*)str, strlen(str), &dummy, NULL);
    GlobalUnlock(hData);
    CloseClipboard();
    ExitProcess(0);
}
